import java.io.*;
import java.util.ArrayList;

// This is Ragnar's code translated to Java.

class pair
{
    int pos, st;
    pair(int p, int s)
    {
        this.pos = p; this.st = s;
    }
}



class fenwick_tree
{
    int[] a;
    public fenwick_tree(int size)
    {
        a = new int[size + 1];
    }

    public int query(int i)
    {
        assert(i >= 0);
        i++;
        int res = 0;
        while(i > 0)
        {
            res += a[i];
            i -= i & (-i);
        }

        return res;
    }

    public void update(int i, int c)
    {
        assert(i >= 0);
        ++i;
        while(i < a.length)
        {
            a[i] += c;
            i += i & (-i);
        }
    }
}

public class ragnarbr {
    static int MMAX = 1000000 + 1;
    static fenwick_tree[] ft = new fenwick_tree[2];
    static pair[][] dffs = new pair[2][100000];

    static ArrayList<ArrayList<pair>> diffs = new ArrayList<ArrayList<pair>>();

    static private BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static private BufferedWriter brw = new BufferedWriter(new OutputStreamWriter(System.out));

    public static void main(String[] args) throws IOException {
        int n, p, q;
        String line1[] = br.readLine().split("\\s");
        n = Integer.parseInt(line1[0]);
        p = Integer.parseInt(line1[1]);

        ft[0] = new fenwick_tree(MMAX / 2 + 1);
        ft[1] = new fenwick_tree(MMAX / 2 + 1);

        diffs.add(new ArrayList<pair>());
        diffs.add(new ArrayList<pair>());

        // how many jumps do we need to go i to the left/right?
        diffs.get(0).add(new pair(0, 0));
        diffs.get(1).add(new pair(-1, 0));
        for(int i = 1, dist = 1; dist <= MMAX + 4000; ++i, dist += i)
            diffs.get(dist % 2).add(new pair(dist, i));

        String line2[] = br.readLine().split("\\s");
        for(int i = 0; i < n; i++)
        {
            int pos = Integer.parseInt(line2[i]);
            update(pos, 1);
        }

        q = Integer.parseInt(br.readLine());
        for(int i = 0; i < q; i++)
        {
            String s = br.readLine();
            char c = s.charAt(0);
            int pos = Integer.parseInt(s.substring(2));
            if(c == 't')
                p = pos;
            else if(c == '+')
                update(pos, 1);
            else if(c == '-')
                update(pos, -1);
            brw.write(query(p) + "\n");
        }
        brw.flush();
        brw.close();
    }

    static void update(int pos, int delta) {
        for(int p = 0; p <= 1; p++) {
            int q = (p + pos) % 2;
            // to the right
            for(int i = 0; i + 1 < diffs.get(p).size() && pos + diffs.get(p).get(i).pos <= MMAX; ++i) {
                // the +2 must be within the division, to make sure -1 is rounded the right way
                int l = (pos + diffs.get(p).get(i).pos + 2) / 2;
                int r = (pos + diffs.get(p).get(i + 1).pos) / 2 + 1;
                int s = diffs.get(p).get(i + 1).st;
                ft[q].update(l, delta * s);
                if(r <= MMAX / 2) ft[q].update(r, -delta * s);
            }

            // to the left
            for(int i = 0; i + 1 < diffs.get(p).size() && pos - diffs.get(p).get(i).pos > 1; ++i) {
                int l = (pos - diffs.get(p).get(i + 1).pos) / 2;
                int r = (pos - diffs.get(p).get(i).pos) / 2;
                int s = diffs.get(p).get(i + 1).st;
                ft[q].update(Math.max(l, 0), delta * s);
                if(r <= MMAX / 2) ft[q].update(r, -delta * s);
            }
        }
    }

    static int query(int pos) { return ft[pos % 2].query(pos / 2); }

}
