import math

best_rate = dict()


def get_rate(name):
    if name not in best_rate:
        best_rate[name] = float('-inf')
    return best_rate[name]


def solve():
    words = input()
    N = int(words.split()[0])
    best_rate["pink"] = 0.0
    for i in range(N):
        O, W, R = input().split()
        R = float(R)
        new_rate = max(get_rate(O), get_rate(W) + math.log(R))
        best_rate[O] = new_rate

    ans = get_rate("blue")
    if ans < -1000.0:
        print("0.000000")
    elif ans > math.log(10):
        print("10.000000")
    else:
        print("{:.8f}".format(math.exp(ans)))


if __name__ == "__main__":
    solve()
